searchNodes=[{"ref":"Chunky.html","title":"Chunky","type":"module","doc":"Extended chunking and enumeration manipulations. Functions Chunky.permutations/1 - Generate all permutations of a set of values, with no duplication Chunky.permutations_size/1 - Calculate the size of a permutation result from Chunky.permutations/1 Chunky.combinations/2 - Generate combinations of a set of values, with no duplication Chunky.combinations_size/2 - Calculate the size of a combanation result from Chunky.combinations/2 Chunky.chunk_length/2 - Chunk an enumerable into a list of specific length chunks For combinations and permutations, it can be helpful compare the differences: UnorderedOrdered No ReplacementChunky.combinations/2Chunky.permutations/1 Replacementunsupportedunsupported And expected outputs from simple string parameters: UnorderedOrdered No Replacement[ &quot;abc&quot;, &quot;abd&quot;, &quot;acd&quot;, &quot;bcd&quot;][&quot;abc&quot;, &quot;acb&quot;, &quot;bac&quot;, &quot;bca&quot;, &quot;cab&quot;, &quot;cba&quot;] Replacement"},{"ref":"Chunky.html#chunk_length/2","title":"Chunky.chunk_length/2","type":"function","doc":"Break a set of values into smaller chunks of a specific length. iex&gt; Chunky.chunk_length([1, 2, 3, 4, 5, 6], 3) [ [1, 2, 3], [4, 5, 6]] iex&gt; Chunky.chunk_length(&quot;Sphinx of black quartz, judge my vow&quot;, 5) [&quot;Sphin&quot;, &quot;x of &quot;, &quot;black&quot;, &quot; quar&quot;, &quot;tz, j&quot;, &quot;udge &quot;, &quot;my vo&quot;, &quot;w&quot;] The type of the set of values can be: a list of any type, like [1, 2, 3] or [:a, :b, %{}] a string or binary, like &quot;abcd&quot; a tuple, like {1, :b, &quot;asdf&quot;} a range, like 1..4 or 3..-1 When a set is chunked, the resulting list will contain values in the shape of the original; a chunked list will contains lists, chunked tuples will contain tuples, chunked strings will contain strings. The only exception is ranges, which will result in lists. Supported Chunking Types The following types of sets are supported for chunking: List A list with just about any kind of value can be chunked, and the result will be a list of lists: iex&gt; Chunky.chunk_length([1, 2, 3, 4, 5, 6, 7, 8], 3) [ [1, 2, 3], [4, 5, 6], [7, 8]] iex&gt; Chunky.chunk_length([:a, 1, :b, 2, :c, 3, :d, 4, :e, 5, :f, 6], 4) [ [:a, 1, :b, 2], [:c, 3, :d, 4], [:e, 5, :f, 6]] Collections, types, and other values can be in the chunked set: iex&gt; Chunky.chunk_length([~D(2019-12-05), %{a: &quot;foo&quot;}, {:tup, :le}, true], 2) [ [~D(2019-12-05), %{a: &quot;foo&quot;}], [{:tup, :le}, true]] String/Binary Chunked strings are returned as a list of strings. Chunky works with full UTF-8, including multi-code point glyphs like emojis and variable emojis. iex&gt; Chunky.chunk_length(&quot;abcdefghijklmnop&quot;, 7) [ &quot;abcdefg&quot;, &quot;hijklmn&quot;, &quot;op&quot;] iex&gt; Chunky.chunk_length(&quot;😀🤷🏽‍♀️⭐️℉😐&quot;, 3) [&quot;😀🤷🏽‍♀️⭐️&quot;, &quot;℉😐&quot;] Tuple When tuples are chunked, the resulting list will also contain tuples. As part of the chunking process the original tuple is converted to a list, before the final values are re-assembled into tuples. Like working with lists, tuples can contain any values: iex&gt; Chunky.chunk_length({:a, :b, :c, :d, :e, :f, :g, :h, :i, :j}, 4) [ {:a, :b, :c, :d}, {:e, :f, :g, :h}, {:i, :j}] iex&gt; Chunky.chunk_length({:task, ~D(2019-12-09), %{value: &quot;timer&quot;}, true, 123, &quot;foo&quot;}, 2) [ {:task, ~D(2019-12-09)}, {%{value: &quot;timer&quot;}, true}, {123, &quot;foo&quot;}] Ranges Ranges can be used to create chunks over ordered lists of numbers. Before chunking the provided range is converted into a list. Increasing or decreasing ranges are supported. iex&gt; Chunky.chunk_length(1..20, 5) [ [1, 2, 3, 4, 5], [6, 7, 8, 9, 10], [11, 12, 13, 14, 15], [16, 17, 18, 19, 20]] iex&gt; Chunky.chunk_length(10..-10, 3) [ [10, 9, 8], [7, 6, 5], [4, 3, 2], [1, 0, -1], [-2, -3, -4], [-5, -6, -7], [-8, -9, -10] ]"},{"ref":"Chunky.html#combinations/2","title":"Chunky.combinations/2","type":"function","doc":"Generate the set of combinations from a set of values. The type of the set of values can be: a list of any type, like [1, 2, 3] or [:a, :b, %{}] a string or binary, like &quot;abcd&quot; a tuple, like {1, :b, &quot;asdf&quot;} a range, like 1..4 or 3..-1 This is not lazy generated, so a combination of a large set may take awhile. Keep in mind that the total number of combinations of k length for a set of n values is: n! ---------- k!(n - k)! When a set is generated, the resulting list will contain values in the shape of the original; a combination from a list will contains lists, combination from tuples will contain tuples, combination from strings will contain strings. The only exception is ranges, which will result in lists. So, for instance, a combination from a string will result in a list of strings. Chunky should handle Unicode just fine: iex&gt; Chunky.combinations(&quot;😀★⍵😀🤷🏽‍♀️&quot;, 3) [&quot;😀★⍵&quot;, &quot;😀★😀&quot;, &quot;😀★🤷🏽‍♀️&quot;, &quot;😀⍵😀&quot;, &quot;😀⍵🤷🏽‍♀️&quot;, &quot;😀😀🤷🏽‍♀️&quot;, &quot;★⍵😀&quot;, &quot;★⍵🤷🏽‍♀️&quot;, &quot;★😀🤷🏽‍♀️&quot;, &quot;⍵😀🤷🏽‍♀️&quot;] Supported Combinations The Chunky.combinations/2 function can work with sets of any size (memory and time permitting). Examples that follow usually use sets with a length of 2 or 3 for ease of documentation. The following types of sets are supported as combinations: List A list with just about any kind of value can be permuted, and the result will be a list of lists: iex&gt; Chunky.combinations([1, 5, 7, 11, 27], 3) [[1, 5, 7], [1, 5, 11], [1, 5, 27], [1, 7, 11], [1, 7, 27], [1, 11, 27], [5, 7, 11], [5, 7, 27], [5, 11, 27], [7, 11, 27]] iex&gt; Chunky.combinations([:a, &quot;b&quot;, 3, 26.2], 2) [ [:a, &quot;b&quot;], [:a, 3], [:a, 26.2], [&quot;b&quot;, 3], [&quot;b&quot;, 26.2], [3, 26.2] ] Collections, types, and other values can be combined as well: iex&gt; Chunky.combinations([~D(2019-12-05), %{a: &quot;foo&quot;}, {:tup, :le}, [1, 2, 3]], 3) [ [~D[2019-12-05], %{a: &quot;foo&quot;}, {:tup, :le}], [~D[2019-12-05], %{a: &quot;foo&quot;}, [1, 2, 3]], [~D[2019-12-05], {:tup, :le}, [1, 2, 3]], [%{a: &quot;foo&quot;}, {:tup, :le}, [1, 2, 3]] ] String/Binary Combined strings are returned as a list of strings. Chunky works with full UTF-8, including multi-code point glyphs like emojis and variable emojis. iex&gt; Chunky.combinations(&quot;abcd&quot;, 2) [&quot;ab&quot;, &quot;ac&quot;, &quot;ad&quot;, &quot;bc&quot;, &quot;bd&quot;, &quot;cd&quot;] iex&gt; Chunky.combinations(&quot;😀🤷🏽‍♀️⭐️🧁🦴&quot;, 3) [ &quot;😀🤷🏽‍♀️⭐️&quot;, &quot;😀🤷🏽‍♀️🧁&quot;, &quot;😀🤷🏽‍♀️🦴&quot;, &quot;😀⭐️🧁&quot;, &quot;😀⭐️🦴&quot;, &quot;😀🧁🦴&quot;, &quot;🤷🏽‍♀️⭐️🧁&quot;, &quot;🤷🏽‍♀️⭐️🦴&quot;, &quot;🤷🏽‍♀️🧁🦴&quot;, &quot;⭐️🧁🦴&quot; ] Tuple When tuples are combined, the resulting list will also contain tuples. As part of the combination the original tuple is converted to a list, before the final values of the combination are re-assembled into tuples. Like working with lists, tuples can contain any values: iex&gt; Chunky.combinations({:a, :b, :c, :d, :e}, 3) [ {:a, :b, :c}, {:a, :b, :d}, {:a, :b, :e}, {:a, :c, :d}, {:a, :c, :e}, {:a, :d, :e}, {:b, :c, :d}, {:b, :c, :e}, {:b, :d, :e}, {:c, :d, :e} ] iex&gt; Chunky.combinations({:task, ~D(2019-12-09), %{value: &quot;timer&quot;}, [1, 2, 3]}, 3) [ {:task, ~D[2019-12-09], %{value: &quot;timer&quot;}}, {:task, ~D[2019-12-09], [1, 2, 3]}, {:task, %{value: &quot;timer&quot;}, [1, 2, 3]}, {~D[2019-12-09], %{value: &quot;timer&quot;}, [1, 2, 3]} ] Ranges Ranges can be used to create combinations over ordered lists of numbers. Before combination the provided range is converted into a list. Increasing or decreasing ranges are supported. iex&gt; Chunky.combinations(3..6, 2) [ [3, 4], [3, 5], [3, 6], [4, 5], [4, 6], [5, 6] ] iex&gt; Chunky.combinations(-10..-13, 3) [ [-10, -11, -12], [-10, -11, -13], [-10, -12, -13], [-11, -12, -13] ] Examples iex&gt; Chunky.combinations([4, 3, 4, 3], 3) [[4, 3, 4], [4, 3, 3], [4, 4, 3], [3, 4, 3]] iex&gt; Chunky.combinations(&quot;abcd&quot;, 2) [&quot;ab&quot;, &quot;ac&quot;, &quot;ad&quot;, &quot;bc&quot;, &quot;bd&quot;, &quot;cd&quot;] iex&gt; Chunky.combinations({:a, :b, :c}, 1) [ {:a}, {:b}, {:c}] iex&gt; Chunky.combinations(2..-2, 3) [ [2, 1, 0], [2, 1, -1], [2, 1, -2], [2, 0, -1], [2, 0, -2], [2, -1, -2], [1, 0, -1], [1, 0, -2], [1, -1, -2], [0, -1, -2]]"},{"ref":"Chunky.html#combinations_size/2","title":"Chunky.combinations_size/2","type":"function","doc":"Compute the size of the result of calling Chunky.combinations/2, without actually running a combination. This is particularly useful, as the number of results of a combination of k elements from a set of n, grows as: n! ---------- k!(n - k)! This can be a quick sanity check before running a permutation. Works with all of the parameters that work with Chunky.permutations/1, as a drop in replacement. Uses a closed form factorial to calculate the size of the list that would result from an indentical call to Chunky.permutations/1: iex&gt; Chunky.combinations_size(&quot;abcd&quot;, 2) 6 iex&gt; Chunky.combinations_size(1..10, 4) 210 iex&gt; Chunky.combinations_size({:a, :b, :c, :d, :e, :f, :g}, 5) 21 iex&gt; Chunky.combinations_size([2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24, 26, 28, 30], 3) 455 See Chunky.combinations/2 for more details on supported types."},{"ref":"Chunky.html#permutations/1","title":"Chunky.permutations/1","type":"function","doc":"Generate all of the permutations, without duplicates, from a set of values. The type of the set of values can be: a list of any type, like [1, 2, 3] or [:a, :b, %{}] a string or binary, like &quot;abcd&quot; a tuple, like {1, :b, &quot;asdf&quot;} a range, like 1..4 or 3..-1 This is not lazy generated, so a permutation of a large set may take awhile. Keep in mind that the total number of permutations for a set of N values is N!. When a set is permuted, the resulting list will contain values in the shape of the original; a permuted list will contains lists, permuted tuples will contain tuples, permuted strings will contain strings. The only exception is ranges, which will result in lists. So, for instance, a permuted string will result in a list of strings. Chunky should handle Unicode just fine: iex&gt; Chunky.permutations(&quot;😀★⍵&quot;) [&quot;😀★⍵&quot;, &quot;😀⍵★&quot;, &quot;★😀⍵&quot;, &quot;★⍵😀&quot;, &quot;⍵😀★&quot;, &quot;⍵★😀&quot;] Supported Permutations The Chunky.permutations/1 function can work with sets of any size (memory and time permitting). Examples that follow usually use sets with a length of 3 for ease of documentation. The following types of sets are supported as permutations: List A list with just about any kind of value can be permuted, and the result will be a list of lists: iex&gt; Chunky.permutations([1, 2, 3]) [[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]] iex&gt; Chunky.permutations([:a, &quot;b&quot;, 3]) [ [:a, &quot;b&quot;, 3], [:a, 3, &quot;b&quot;], [&quot;b&quot;, :a, 3], [&quot;b&quot;, 3, :a], [3, :a, &quot;b&quot;], [3, &quot;b&quot;, :a] ] Collections, types, and other values can be permuted as well: iex&gt; Chunky.permutations([~D(2019-12-05), %{a: &quot;foo&quot;}, {:tup, :le}]) [ [~D[2019-12-05], %{a: &quot;foo&quot;}, {:tup, :le}], [~D[2019-12-05], {:tup, :le}, %{a: &quot;foo&quot;}], [%{a: &quot;foo&quot;}, ~D[2019-12-05], {:tup, :le}], [%{a: &quot;foo&quot;}, {:tup, :le}, ~D[2019-12-05]], [{:tup, :le}, ~D[2019-12-05], %{a: &quot;foo&quot;}], [{:tup, :le}, %{a: &quot;foo&quot;}, ~D[2019-12-05]] ] String/Binary Permuted strings are returned as a list of strings. Chunky works with full UTF-8, including multi-code point glyphs like emojis and variable emojis. iex&gt; Chunky.permutations(&quot;abc&quot;) [&quot;abc&quot;, &quot;acb&quot;, &quot;bac&quot;, &quot;bca&quot;, &quot;cab&quot;, &quot;cba&quot;] iex&gt; Chunky.permutations(&quot;😀🤷🏽‍♀️⭐️&quot;) [ &quot;😀🤷🏽‍♀️⭐️&quot;, &quot;😀⭐️🤷🏽‍♀️&quot;, &quot;🤷🏽‍♀️😀⭐️&quot;, &quot;🤷🏽‍♀️⭐️😀&quot;, &quot;⭐️😀🤷🏽‍♀️&quot;, &quot;⭐️🤷🏽‍♀️😀&quot; ] Tuple When tuples are permuted, the resulting list will also contain tuples. As part of the permutation the original tuple is converted to a list, before the final values of the permutation are re-assembled into tuples. Like working with lists, tuples can contain any values: iex&gt; Chunky.permutations({:a, :b, :c}) [ {:a, :b, :c}, {:a, :c, :b}, {:b, :a, :c}, {:b, :c, :a}, {:c, :a, :b}, {:c, :b, :a} ] iex&gt; Chunky.permutations({:task, ~D(2019-12-09), %{value: &quot;timer&quot;}}) [ {:task, ~D[2019-12-09], %{value: &quot;timer&quot;}}, {:task, %{value: &quot;timer&quot;}, ~D[2019-12-09]}, {~D[2019-12-09], :task, %{value: &quot;timer&quot;}}, {~D[2019-12-09], %{value: &quot;timer&quot;}, :task}, {%{value: &quot;timer&quot;}, :task, ~D[2019-12-09]}, {%{value: &quot;timer&quot;}, ~D[2019-12-09], :task} ] Ranges Ranges can be used to create permutations over ordered lists of numbers. Before permutation the provided range is converted into a list. Increasing or decreasing ranges are supported. iex&gt; Chunky.permutations(3..5) [[3, 4, 5], [3, 5, 4], [4, 3, 5], [4, 5, 3], [5, 3, 4], [5, 4, 3]] iex&gt; Chunky.permutations(-10..-12) [ [-10, -11, -12], [-10, -12, -11], [-11, -10, -12], [-11, -12, -10], [-12, -10, -11], [-12, -11, -10] ] Examples iex&gt; Chunky.permutations([1, 2, 3]) [[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]] iex&gt; Chunky.permutations(&quot;abc&quot;) [&quot;abc&quot;, &quot;acb&quot;, &quot;bac&quot;, &quot;bca&quot;, &quot;cab&quot;, &quot;cba&quot;] iex&gt; Chunky.permutations({:a, :b, :c}) [ {:a, :b, :c}, {:a, :c, :b}, {:b, :a, :c}, {:b, :c, :a}, {:c, :a, :b}, {:c, :b, :a} ] iex&gt; Chunky.permutations(1..-1) [ [1, 0, -1], [1, -1, 0], [0, 1, -1], [0, -1, 1], [-1, 1, 0], [-1, 0, 1]]"},{"ref":"Chunky.html#permutations_size/1","title":"Chunky.permutations_size/1","type":"function","doc":"Compute the size of the result of calling Chunky.permutations/1, without actually running a permutation. The results of a permutation of a set of n items grows at a rate of n!. This can be a quick sanity check before running a permutation. Works with all of the parameters that work with Chunky.permutations/1, as a drop in replacement. Uses a closed form factorial to calculate the size of the list that would result from an indentical call to Chunky.permutations/1: iex&gt; Chunky.permutations_size(&quot;abcd&quot;) 24 iex&gt; Chunky.permutations_size(1..10) 3628800 iex&gt; Chunky.permutations_size({:a, :b, :c, :d, :e, :f, :g}) 5040 iex&gt; Chunky.permutations_size([1, 4, 8, 10, 15, 37, 91, 113, 3345, 8765, 101010, 345678]) 479001600 See Chunky.permutations/1 for more details on supported types."},{"ref":"Chunky.Fraction.html","title":"Chunky.Fraction","type":"module","doc":"Functions for creating and manipulating fractions."},{"ref":"Chunky.Fraction.html#add/3","title":"Chunky.Fraction.add/3","type":"function","doc":"Add two fractions, or a fraction and an integer, and return the (optionally simplified) result. Examples iex&gt; Fraction.add(Fraction.new(1, 2), Fraction.new(-8, 3)) %Fraction{num: -13, den: 6} iex&gt; Fraction.add(Fraction.new(3, 4), Fraction.new(3, 4), simplify: true) %Fraction{num: 3, den: 2} iex&gt; Fraction.add(Fraction.new(1, 3), 5) %Fraction{num: 16, den: 3} iex&gt; Fraction.add(2, Fraction.new(5, 4)) %Fraction{num: 13, den: 4}"},{"ref":"Chunky.Fraction.html#components/1","title":"Chunky.Fraction.components/1","type":"function","doc":"Extract the numerator and denominator of a fraction as a tuple of values. Examples iex&gt; Fraction.new(1, 37) |&gt; Fraction.components() {1, 37} iex&gt; Fraction.new(0, 3) |&gt; Fraction.components() {0, 3}"},{"ref":"Chunky.Fraction.html#divide/3","title":"Chunky.Fraction.divide/3","type":"function","doc":"Divide two fractions, or a fraction and an integer and return the (optionally simplified) result. Examples iex&gt; Fraction.divide(Fraction.new(3, 4), Fraction.new(-7, 2)) %Fraction{num: -6, den: 28} iex&gt; Fraction.divide(Fraction.new(28, 4), 4, simplify: true) %Fraction{num: 7, den: 4} iex&gt; Fraction.divide(60, Fraction.new(7, 12)) %Fraction{num: 720, den: 7}"},{"ref":"Chunky.Fraction.html#eq?/2","title":"Chunky.Fraction.eq?/2","type":"function","doc":"Compare a fraction with an integer or fraction using equals comparison. Examples iex&gt; Fraction.eq?(Fraction.new(7, 9), Fraction.new(3, 5)) false iex&gt; Fraction.eq?(3, Fraction.new(12, 4)) true iex&gt; Fraction.eq?(Fraction.new(-3, 12), -2) false"},{"ref":"Chunky.Fraction.html#get_remainder/1","title":"Chunky.Fraction.get_remainder/1","type":"function","doc":"Get the fractional part left after removing any whole components from the fraction. Example iex&gt; Fraction.new(3, 45) |&gt; Fraction.get_remainder() %Fraction{num: 3, den: 45} iex&gt; Fraction.new(7, 3) |&gt; Fraction.get_remainder() %Fraction{num: 1, den: 3} iex&gt; Fraction.new(-10, 4) |&gt; Fraction.get_remainder() %Fraction{num: -2, den: 4}"},{"ref":"Chunky.Fraction.html#get_whole/1","title":"Chunky.Fraction.get_whole/1","type":"function","doc":"Get the whole component of a fraction. Examples iex&gt; Fraction.new(3, 7) |&gt; Fraction.get_whole() 0 iex&gt; Fraction.new(22, 7) |&gt; Fraction.get_whole() 3 iex&gt; Fraction.new(-10, 2) |&gt; Fraction.get_whole() -5"},{"ref":"Chunky.Fraction.html#gt?/2","title":"Chunky.Fraction.gt?/2","type":"function","doc":"Compare a fraction with an integer or fraction using greater than comparison. Examples iex&gt; Fraction.gt?(Fraction.new(7, 9), Fraction.new(3, 5)) true iex&gt; Fraction.gt?(3, Fraction.new(15, 4)) false iex&gt; Fraction.gt?(Fraction.new(-3, 12), -2) true"},{"ref":"Chunky.Fraction.html#gte?/2","title":"Chunky.Fraction.gte?/2","type":"function","doc":"Compare a fraction with an integer or fraction using greater than or equal comparison. Examples iex&gt; Fraction.gte?(Fraction.new(3, 9), Fraction.new(1, 3)) true iex&gt; Fraction.gte?(3, Fraction.new(15, 4)) false iex&gt; Fraction.gte?(Fraction.new(-3, 12), -2) true"},{"ref":"Chunky.Fraction.html#has_whole?/1","title":"Chunky.Fraction.has_whole?/1","type":"function","doc":"Determine if a fraction is greater than 1, and has a whole number component. Examples iex&gt; Fraction.new(3, 17) |&gt; Fraction.has_whole?() false iex&gt; Fraction.new(22, 7) |&gt; Fraction.has_whole?() true"},{"ref":"Chunky.Fraction.html#integer_nth_root?/3","title":"Chunky.Fraction.integer_nth_root?/3","type":"function","doc":"Determine if the n-th root of a number is a whole integer. If the result n-th root is within epsilon of a whole integer, we consider the result an integer n-th root. This calcualtion runs the fast converging n-th root at a higher epsilon than it&#39;s configured to use for comparison and testing of the result value. Examples iex&gt; Fraction.integer_nth_root?(27, 3) {true, 3} iex&gt; Fraction.integer_nth_root?(1234, 6) {false, :no_integer_nth_root, 3.2750594908836885}"},{"ref":"Chunky.Fraction.html#is_negative?/1","title":"Chunky.Fraction.is_negative?/1","type":"function","doc":"Determine if a fraction is negative. Examples iex&gt; Fraction.new(-3, 4) |&gt; Fraction.is_negative?() true"},{"ref":"Chunky.Fraction.html#is_positive?/1","title":"Chunky.Fraction.is_positive?/1","type":"function","doc":"Determine if a fraction is positive. Examples iex&gt; Fraction.new(-3, 4) |&gt; Fraction.is_positive?() false"},{"ref":"Chunky.Fraction.html#is_simplified?/1","title":"Chunky.Fraction.is_simplified?/1","type":"function","doc":"Determine if a fraction is in simplified form. Examples iex&gt; Fraction.new(2, 4) |&gt; Fraction.is_simplified?() false iex&gt; Fraction.new(-10, 4) |&gt; Fraction.is_simplified?() false iex&gt; Fraction.new(0, 7) |&gt; Fraction.is_simplified?() false iex&gt; Fraction.new(22, 7) |&gt; Fraction.is_simplified?() true"},{"ref":"Chunky.Fraction.html#is_whole?/1","title":"Chunky.Fraction.is_whole?/1","type":"function","doc":"Determine if a fraction exactly represents a whole number, with no remainder. Examples iex&gt; Fraction.new(5, 3) |&gt; Fraction.is_whole?() false iex&gt; Fraction.new(-22, 11) |&gt; Fraction.is_whole?() true"},{"ref":"Chunky.Fraction.html#is_zero?/1","title":"Chunky.Fraction.is_zero?/1","type":"function","doc":"Does a fraction represent a zero value? Examples iex&gt; Fraction.new(3, 134) |&gt; Fraction.is_zero?() false iex&gt; Fraction.new(0, 34) |&gt; Fraction.is_zero?() true"},{"ref":"Chunky.Fraction.html#lcm/1","title":"Chunky.Fraction.lcm/1","type":"function","doc":""},{"ref":"Chunky.Fraction.html#lcm/2","title":"Chunky.Fraction.lcm/2","type":"function","doc":""},{"ref":"Chunky.Fraction.html#lt?/2","title":"Chunky.Fraction.lt?/2","type":"function","doc":"Compare a fraction with an integer or fraction using less than comparison. Examples iex&gt; Fraction.lt?(Fraction.new(7, 9), Fraction.new(3, 5)) false iex&gt; Fraction.lt?(3, Fraction.new(15, 4)) true iex&gt; Fraction.lt?(Fraction.new(-3, 12), -2) false"},{"ref":"Chunky.Fraction.html#lte?/2","title":"Chunky.Fraction.lte?/2","type":"function","doc":"Compare a fraction with an integer or fraction using less than or equal comparison. Examples iex&gt; Fraction.lte?(Fraction.new(7, 9), Fraction.new(3, 5)) false iex&gt; Fraction.lte?(3, Fraction.new(15, 4)) true iex&gt; Fraction.lte?(Fraction.new(-24, 12), -2) true"},{"ref":"Chunky.Fraction.html#multiply/3","title":"Chunky.Fraction.multiply/3","type":"function","doc":"Multiply two fractions, or a fraction and an integer and return the (optionally simplified) result. Examples iex&gt; Fraction.multiply(Fraction.new(3, 7), Fraction.new(22, 7)) %Fraction{num: 66, den: 49} iex&gt; Fraction.multiply(Fraction.new(2, 9), 33, simplify: true) %Fraction{num: 22, den: 3} iex&gt; Fraction.multiply(4, Fraction.new(12, 5)) %Fraction{num: 48, den: 5}"},{"ref":"Chunky.Fraction.html#new/1","title":"Chunky.Fraction.new/1","type":"function","doc":"Create a whole number fraction from an integer. Examples iex&gt; Fraction.new(4) %Fraction{num: 4, den: 1} iex&gt; Fraction.new(-22) %Fraction{num: -22, den: 1}"},{"ref":"Chunky.Fraction.html#new/2","title":"Chunky.Fraction.new/2","type":"function","doc":"Create a new fraction from two integers. Integers are stored as component numerator and denominator parts, and are only simplified when explicity told to. Fractions representing a negative number will always carry the negative sign on the numerator. While a denominator with a zero value is undefined, a 0 numerator is acceptable, and will be manipulated normally. Examples iex&gt; Fraction.new(1, 3) %Fraction{num: 1, den: 3} iex&gt; Fraction.new(22, -7) %Fraction{num: -22, den: 7} iex&gt; Fraction.new(17, 0) {:error, :invalid_denominator} iex&gt; Fraction.new(0, 37) %Fraction{num: 0, den: 37}"},{"ref":"Chunky.Fraction.html#normalize/2","title":"Chunky.Fraction.normalize/2","type":"function","doc":"Change a combination of fractions, or fractions and integers, into the same denominator. Example iex&gt; Fraction.normalize(Fraction.new(3, 4), Fraction.new(1, 7)) { %Fraction{num: 21, den: 28}, %Fraction{num: 4, den: 28} } iex&gt; Fraction.normalize(3, Fraction.new(2, 5)) { %Fraction{num: 15, den: 5}, %Fraction{num: 2, den: 5} } iex&gt; Fraction.normalize(Fraction.new(6, 4), 2) { %Fraction{num: 6, den: 4}, %Fraction{num: 8, den: 4} }"},{"ref":"Chunky.Fraction.html#normalize_all/1","title":"Chunky.Fraction.normalize_all/1","type":"function","doc":"Normalize (move to the same denominator) all of the fractions and integers in a list. At least one member of the list must be a fraction. Integers will be automatically converted to normalized fractions. Examples iex&gt; Fraction.normalize_all([Fraction.new(1, 2), Fraction.new(2, 3), Fraction.new(3, 4), 7]) [ %Fraction{den: 12, num: 6}, %Fraction{den: 12, num: 8}, %Fraction{den: 12, num: 9}, %Fraction{den: 12, num: 84} ]"},{"ref":"Chunky.Fraction.html#nth_root/3","title":"Chunky.Fraction.nth_root/3","type":"function","doc":"Generalized integer nth root, from: https://github.com/acmeism/RosettaCodeData/blob/master/Task/Nth-root/Elixir/nth-root.elixir based on a fast converging Newton&#39;s Method process. Examples iex&gt; nth_root(8, 3) 2.0 iex&gt; nth_root(27, 3) 3.0 iex&gt; nth_root(78125, 7) 5.0"},{"ref":"Chunky.Fraction.html#power/3","title":"Chunky.Fraction.power/3","type":"function","doc":"Use fractions in power/exponent calculations. The base or the power (or both) can be fractions. Fractions taken to an integer power will behave as expected: iex&gt; Fraction.power(Fraction.new(3, 4), 7) %Chunky.Fraction{den: 16384, num: 2187} Fractions or integers taken to a fractional power will not always return expected values, as most fractional powers do not have a result that can be represented as a fraction. By default the power functions will return an error value in these cases: iex&gt; Fraction.power(9, Fraction.new(7, 13)) {:error, :no_fractional_power} If you want the floating point fractional result, you can use the allow_irrational flag: iex&gt; Fraction.power(9, Fraction.new(7, 13), allow_irrational: true) 3.26454673038995 When calculating the fractional power of a value, an epsilon value is used as part of the n-th root finding and resulting analysis The epsilon determines how close to a whole number different components of the resulting fractions need to be, to be treated as whole numbers. Options simplify - Boolean. Optionally simplify the return fraction epsilon - Float. Small number used to compare how close two values are allow_irrational - Boolean. Allow a non-fractional (irrational) result to be returned Examples iex&gt; Fraction.power(Fraction.new(7, 32), Fraction.new(30, 5)) %Fraction{num: 117649, den: 1073741824} iex&gt; Fraction.power(Fraction.new(3, 5), 3) %Fraction{num: 27, den: 125} iex&gt; Fraction.power(4, Fraction.new(-4, 8)) %Fraction{num: 1, den: 2} iex&gt; Fraction.power(9, Fraction.new(7, 13), allow_irrational: true) 3.26454673038995"},{"ref":"Chunky.Fraction.html#reciprocal/2","title":"Chunky.Fraction.reciprocal/2","type":"function","doc":"Create the reciprocal of a fraction, optionally simplifying the result. Negative fractions will switch the sign to carry on the new numerator. Trying to take the reciprocal of a zero fraction will result in an error. Examples iex&gt; Fraction.new(3, 4) |&gt; Fraction.reciprocal() %Fraction{num: 4, den: 3} iex&gt; Fraction.new(-4, 40) |&gt; Fraction.reciprocal(simplify: true) %Fraction{num: -10, den: 1} iex&gt; Fraction.new(0, 3) |&gt; Fraction.reciprocal() {:error, :invalid_denominator}"},{"ref":"Chunky.Fraction.html#simplify/1","title":"Chunky.Fraction.simplify/1","type":"function","doc":"Simplify a fraction. Examples iex&gt; Fraction.new(6, 8) |&gt; Fraction.simplify() %Fraction{num: 3, den: 4} iex&gt; Fraction.new(24, 8) |&gt; Fraction.simplify() %Fraction{num: 3, den: 1} iex&gt; Fraction.new(22, 7) |&gt; Fraction.simplify() %Fraction{num: 22, den: 7}"},{"ref":"Chunky.Fraction.html#split/1","title":"Chunky.Fraction.split/1","type":"function","doc":"Break a fraction into whole and fractional parts, returning both. Examples iex&gt; Fraction.new(6, 4) |&gt; Fraction.split() {1, %Fraction{num: 2, den: 4}} iex&gt; Fraction.new(-22, 7) |&gt; Fraction.split() {-3, %Fraction{num: -1, den: 7}} iex&gt; Fraction.new(0, 3) |&gt; Fraction.split() {0, %Fraction{num: 0, den: 3}}"},{"ref":"Chunky.Fraction.html#subtract/3","title":"Chunky.Fraction.subtract/3","type":"function","doc":"Subtract two fractions, or a fraction an an integer, and return the (optionally) simplified result. Examples iex&gt; Fraction.subtract(Fraction.new(3, 5), Fraction.new(1, 5)) %Fraction{num: 2, den: 5} iex&gt; Fraction.subtract(2, Fraction.new(-6, 9), simplify: true) %Fraction{num: 8, den: 3} iex&gt; Fraction.subtract(Fraction.new(-2, 4), -5, simplify: true) %Fraction{num: 9, den: 2}"},{"ref":"Chunky.Fraction.html#sum/2","title":"Chunky.Fraction.sum/2","type":"function","doc":"Add a series of fractions and integers. Example iex&gt; Fraction.sum([Fraction.new(3, 4), Fraction.new(5, 7), Fraction.new(8, 11), 1, Fraction.new(249, 308)]) %Fraction{num: 1232, den: 308} iex&gt; Fraction.sum([Fraction.new(3, 4), Fraction.new(5, 7), Fraction.new(8, 11), 1, Fraction.new(249, 308)], simplify: true) %Fraction{num: 4, den: 1}"},{"ref":"Chunky.Grid.html","title":"Chunky.Grid","type":"module","doc":"Functions for creating and manipulating a two dimenesional grid. Internally the grid is ordered as lists of lists, rather than a single list."},{"ref":"Chunky.Grid.html#get_at/2","title":"Chunky.Grid.get_at/2","type":"function","doc":""},{"ref":"Chunky.Grid.html#get_at/3","title":"Chunky.Grid.get_at/3","type":"function","doc":""},{"ref":"Chunky.Grid.html#new/3","title":"Chunky.Grid.new/3","type":"function","doc":""},{"ref":"Chunky.Grid.html#valid_coordinate/2","title":"Chunky.Grid.valid_coordinate/2","type":"function","doc":""},{"ref":"Chunky.Grid.html#valid_coordinate/3","title":"Chunky.Grid.valid_coordinate/3","type":"function","doc":""},{"ref":"Chunky.Grid.html#valid_coordinate?/2","title":"Chunky.Grid.valid_coordinate?/2","type":"function","doc":""},{"ref":"Chunky.Grid.html#valid_coordinate?/3","title":"Chunky.Grid.valid_coordinate?/3","type":"function","doc":""},{"ref":"readme.html","title":"Chunky","type":"extras","doc":"Chunky Fractions, 2D Grids, and Enumeration manipulations in Elixir. iex&gt; Chunky.permutations(&quot;😀🤷🏽‍♀️⭐️&quot;) [ &quot;😀🤷🏽‍♀️⭐️&quot;, &quot;😀⭐️🤷🏽‍♀️&quot;, &quot;🤷🏽‍♀️😀⭐️&quot;, &quot;🤷🏽‍♀️⭐️😀&quot;, &quot;⭐️😀🤷🏽‍♀️&quot;, &quot;⭐️🤷🏽‍♀️😀&quot; ] iex&gt; Chunky.combinations(1..4, 3) [[1, 2, 3], [1, 2, 4], [1, 3, 4], [2, 3, 4]] iex&gt; Chunky.Fraction.power(Chunky.Fraction.new(7, 32), Chunky.Fraction.new(30, 5)) %Chunky.Fraction{num: 117649, den: 1073741824} iex&gt; Chunky.Fraction.power(Chunky.Fraction.new(7, 32), Chunky.Fraction.new(30, 5)) |&gt; IO.puts() 117649/1073741824"},{"ref":"readme.html#installation","title":"Chunky - Installation","type":"extras","doc":"Install by adding chunky to your list of dependencies in mix.exs: def deps do [ {:chunky, &quot;~&gt; 0.6.0&quot;} ] end Chunky documentation can be found on Hexdocs at https://hexdocs.pm/chunky."},{"ref":"readme.html#documentation","title":"Chunky - Documentation","type":"extras","doc":"See Chunky on Hexdocs."}]